package abbot;

public class NoExitSecurityManager extends SecurityManager {
    public void checkPermission(java.security.Permission perm, 
                                Object context) {
        // allow everything
    }
    public void checkPermission(java.security.Permission perm) {
        // allow everything
    }
    public void checkExit(int status) {
        // We only want to disallow Runtime.halt/Runtime.exit 
        // Anything else is ok (e.g. System.runFinalizersOnExit; some VMs do a
        // check there as well -- 1.3 and prior, I think)
        String stack = Log.getStack(Log.FULL_STACK);
        if (stack.indexOf("java.lang.Runtime.exit") != -1
            || stack.indexOf("java.lang.Runtime.halt") != -1) {
            terminate();
            throw new ExitException("Caught application exit", status);
        }
    }
    /** Overload this method to do any context-specific cleanup.  This
        hook is provided since it may not always be possible to catch the
        ExitException explicitly (like when it's caught by someone else, or
        thrown from the event dispatch thread).
    */
    protected void terminate() {
    }
}
