package abbot.awt.extensions;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.event.InputEvent;

/** Provide user actions and identifiers for the ArrowButton component. */

public class ArrowButtonTester extends abbot.tester.awt.ComponentTester {

    /** Set up the editor menu documentation properties. */
    static {
        System.setProperty("actionRoll.menu", "Roll");
        System.setProperty("actionRoll.desc", "Hold down the arrow button");
        System.setProperty("ArrowButtonTester.actionRoll.args",
                           "actionRoll(Component comp, int ms)");
    }

    public String deriveTag(Component comp) {
        return ((example.ArrowButton)comp).getDirection();
    }
    /** Press and hold the button for the given length of time (in ms). */
    public void actionRoll(Component comp, int ms) {
        Dimension size = comp.getSize();
        mousePress(comp, (size.width + 1) / 2, (size.height + 1) / 2,
                   InputEvent.BUTTON1_MASK);
        delay(ms);
        mouseRelease(InputEvent.BUTTON1_MASK);
    }
}
