package abbot.editor;

import javax.swing.table.AbstractTableModel;

import abbot.Log;
import abbot.Resolver;
import abbot.script.ComponentReference;
import abbot.script.InvalidScriptException;

/** Formats a Script for display in a table.  Keeps track of
 * "open" nodes to create a tree-like display
 * NOTE: this is a brute-force implementation with no attempts at
 * optimization.   But it's a very simple tree+table implementation.
 */
class ReferencesModel extends AbstractTableModel {
    private Resolver resolver;

    public ReferencesModel(Resolver resolver) {
        this.resolver = resolver;
    }

    public synchronized int getRowCount() { 
        return resolver.getComponentReferences().size();
    }
    public synchronized int getColumnCount() { return 1; }
    /** Returns the entry object at the given row. */
    public Object getValueAt(int row, int column) {
        return resolver.getComponentReferences().toArray()[row];
    }
    /** Assumes value is XML for a script step. */
    public synchronized void setValueAt(Object value, int row, int col) {
        if (col == 0) {
            Log.debug("Setting value at " + row 
                      + " to " + value);
            try {
                ComponentReference ref =
                    (ComponentReference)getValueAt(row, col);
                ref.fromXML((String)value);
            }
            catch(InvalidScriptException iae) {
                // FIXME show a dialog explaining the improper arguments
                ScriptEditor.showError("Invalid XML", iae.getMessage());
            }
        }
    }
    public String getColumnName(int col) { return ""; }
    public boolean isCellEditable(int row, int col) {
        return true;
    }
    public Class getColumnClass(int col) {
        if (col == 0)
            return ComponentReference.class;
        return Object.class;
    }
}


