package abbot.editor.recorder;

import java.awt.Dialog;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.Window;

import abbot.Resolver;
import abbot.script.Action;
import abbot.script.ComponentReference;
import abbot.script.Step;

/**
 * Record basic semantic events you might find on an Window. <p>
 */
public class DialogRecorder extends WindowRecorder {

    public DialogRecorder(Resolver resolver) {
        super(resolver);
    }

    protected Step createMove(Window window, Point where) {
        ComponentReference ref = getResolver().addComponent(window);
        return new Action(getResolver(), 
                          null, "actionMove",
                          new String[] { ref.getID(),
                                         String.valueOf(where.x),
                                         String.valueOf(where.y)
                          }, Dialog.class);
    }

    protected Step createResize(Window window, Dimension size) {
        ComponentReference ref = getResolver().addComponent(window);
        return new Action(getResolver(), 
                          null, "actionResize",
                          new String[] { ref.getID(),
                                         String.valueOf(size.width),
                                         String.valueOf(size.height),
                          }, Dialog.class);
    }
}

