package abbot.script;

import abbot.ExitException;
import abbot.Log;
import abbot.util.AbstractEventExceptionHandler;

public class EventExceptionHandler extends AbstractEventExceptionHandler {
    protected void exceptionCaught(Throwable thr) {
        if (thr.getClass().getName().
            equals(ExitException.class.getName())) {
            Log.log("Application attempted exit from the event "
                    + "dispatch thread, ignoring it");
            Log.log(thr);
        }
        else if (thr instanceof NullPointerException
                 && Log.getStack(Log.FULL_STACK, thr).
                 indexOf("createHierarchyEvents") != -1) {
            // java 1.3 hierarchy listener bug, most likely
            Log.log("Apparent hierarchy NPE bug:\n"
                    + Log.getStack(Log.FULL_STACK, thr));
        }
        else {
            Log.warn("Unexpected exception while dispatching events:");
            Log.warn(thr);
        }
    }
}
