package abbot.util;

public class Properties {

    /** Load an integer system property, keeping it within the given valid
        range. */
    public static int getProperty(String name, int min, int max, int defValue){
        int value = defValue;
        String prop = System.getProperty(name);
        if (prop != null) {
            try {
                value = Integer.parseInt(prop);
                if (value < min) value = min;
                else if (value > max) value = max;
            }
            catch(Exception exc) {
            }
        }
        return value;
    }
    /** Load a long system property, keeping it within the given valid
        range. */
    public static long getProperty(String name, long min, long max,
                                   long defValue){
        long value = defValue;
        String prop = System.getProperty(name);
        if (prop != null) {
            try {
                value = Long.parseLong(prop);
                if (value < min) value = min;
                else if (value > max) value = max;
            }
            catch(Exception exc) {
            }
        }
        return value;
    }
    /** Load a String property, using a default value if it doesn't exist. */
    public static String getProperty(String name, String defValue) {
        String value = System.getProperty(name);
        if (value == null)
            value = defValue;
        return value;
    }
}
