
package com.ibm.abbot.tester.swt;

import org.eclipse.swt.widgets.*;
import org.eclipse.swt.graphics.*;

/**
 * Provides widget-specific actions, assertions, and getter methods for
 * widgets of type Group.
 */
public class GroupTester extends CompositeTester {
	/* Widget properties that are obtainable by member getter functions */
	protected Rectangle clientArea;
	protected String text;
	
	/**
	 * Sets the above properties to their current values for the given widget. 
	 * NOTE: This should be called in a block of code synchronized on this
	 * tester.
	 */
	protected synchronized void getProperties(final Group group){
		super.getProperties(group);
		Robot.syncExec(group.getDisplay(),this,new Runnable(){
			public void run(){
				clientArea = group.getClientArea();
				text = group.getText();
			}
		});			
	}

	/**
	 * These getter methods return a particular property of the given widget.
	 * @see the corresponding member function in class Widget   
	 */ 
	/* Begin getters */
	public synchronized Rectangle getClientArea(Group group){
		getProperties(group);
		return clientArea;
	}
	
	public synchronized String getText(Group group){
		getProperties(group);
		return text;
	}
	/* End getters */
}
