
package com.ibm.abbot.tester.swt;

import org.eclipse.swt.widgets.*;

/**
 * Provides widget-specific actions, assertions, and getter methods for
 * widgets of type ProgressBar.
 */
public class ProgressBarTester extends ControlTester {
	/* Widget properties that are obtainable by member getter functions */
	protected int minimum,maximum,selection;

	/**
	 * Sets the above properties to their current values for the given widget. 
	 * NOTE: This should be called in a block of code synchronized on this
	 * tester.
	 */	
	protected synchronized void getProperties(final ProgressBar bar){
		super.getProperties(bar);
		Robot.syncExec(bar.getDisplay(),this,new Runnable(){
			public void run(){
				minimum = bar.getMinimum();
				maximum = bar.getMaximum();
				selection = bar.getSelection();
			}
		});
	}

	/**
	 * These getter methods return a particular property of the given widget.
	 * @see the corresponding member function in class Widget   
	 */ 
	/* Begin getters */	
	public synchronized int getMaximum(ProgressBar bar) {
		getProperties(bar);
		return maximum;
	}

	public synchronized int getMinimum(ProgressBar bar) {
		getProperties(bar);
		return minimum;
	}
	
	public synchronized int getSelection(ProgressBar bar) {
		getProperties(bar);
		return selection;
	}
	/* End getters */
}
