package example;

import java.applet.Applet;
import java.awt.Button;
import java.awt.Dialog;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Label;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

/** A very simple AWT-based applet.  See applet.xml and applet.hmlt.<p>
    <blockquote><code><pre>
    &lt;applet code="example.SimpleApplet" width=250 height&gt;
    &lt;/applet&gt;
    </pre></code></blockquote>
    <p>
    @author kelvinr@users.sourceforge.net, twall@users.sourceforge.net
 */

public class SimpleApplet extends Applet { 

    String msg = "This is a simple applet"; 

    public void init() { 
        Label push = new Label("Press a button"); 
        final Button hi = new Button("High"); 
        final Button lo = new Button("Low"); 
        final Button show = new Button("?");
        final Dialog dialog = new Dialog(new Frame(), "Dialog", true);
        dialog.add(new Label("This is a dialog"));
        dialog.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent we) {
                we.getWindow().hide();
            }
        });
        
        // Adds labels and buttons to applet window 
        add(push); 
        add(hi); 
        add(lo); 
        add(show);

        ActionListener al = new ActionListener() {
            public void actionPerformed(ActionEvent ae) { 
                if (ae.getSource() == hi) {
                    msg = "Up, up and away!"; 
                } 
                else if (ae.getSource() == lo) {
                    msg = "How low can you go?"; 
                } 
                else {
                    dialog.pack();
                    dialog.show();
                }
                repaint(); 
            }
        };
        hi.addActionListener(al); 
        lo.addActionListener(al); 
        show.addActionListener(al);
    } 

    public void paint(Graphics g) { 
        g.drawString(msg, 20, 120); 
    } 

} 

