package abbot.editor;

import junit.extensions.abbot.TestHelper;
import junit.framework.Test;
import junit.framework.TestSuite;
import abbot.i18n.*;

/** 
    Test suite of all available tests for the script editor.
    <p>
    @author twall
*/

public class EditorTestSuite extends TestSuite {

    public EditorTestSuite(String name) {
        super(name);
    }

    /**
     * Assembles and returns a test suite containing tests for all available
     * Editor tests, excluding scripts.
     */
    public static Test suite() {
        Class[] classes = {
            ScriptModelTest.class,
            ScriptEditorTest.class,
        };
        TestSuite suite = (TestSuite)TestHelper.generateSuite(classes);
        suite.addTest(abbot.editor.editors.AllTests.suite());
        return suite;
    }

    /**
     * Runs the full test suite.
     */
    public static void main(String[] args) {
        TestHelper.runTests(args, EditorTestSuite.class);
    }
}
