package abbot.editor;

import java.io.File;

import junit.extensions.abbot.TestHelper;
import junit.framework.TestCase;

/** Tests for the script editor proper. */

public class ScriptEditorTest extends TestCase {

    ScriptEditor editor = null;

    protected void tearDown() {
        if (editor != null)
            editor.dispose();
        // Make sure we don't have any security managers left around
        // preventing exits
        System.setSecurityManager(null);
    }

    /** Open a new, empty script. */
    public void testNewScript() throws Throwable {
        editor = new ScriptEditor();
        // Try a file that exists
        File file = File.createTempFile(getName(), ".xml");
        file.deleteOnExit();
        editor.newScript(file, false);
        // Default script gets a launch + terminate; just add a wait

        // Try a file that doesn't exist
        file = File.createTempFile(getName(), ".xml");
        file.delete();
        editor.newScript(file, false);
        file.deleteOnExit();
    }

    public void xtestDupScript() throws Throwable {
        editor = new ScriptEditor();
        // Try a file that exists
        File file = File.createTempFile(getName(), ".xml");
        file.deleteOnExit();
        editor.newScript(file, true);

        // Try a file that doesn't exist
        file = File.createTempFile(getName(), ".xml");
        file.delete();
        editor.newScript(file, true);
        file.deleteOnExit();
    }

    /** Construct a test case with the given name. */
    public ScriptEditorTest(String name) { super(name); }

    /** Run the default test suite. */
    public static void main(String[] args) {
        TestHelper.runTests(args, ScriptEditorTest.class);
    }
}
