package abbot.editor.editors;

import java.util.ArrayList;

import javax.swing.JComboBox;

import junit.extensions.abbot.ComponentTestFixture;
import junit.extensions.abbot.TestHelper;
import abbot.Log;
import abbot.script.Action;
import abbot.script.ComponentReference;
import abbot.script.Script;

/** Verify ActionEditor operation. */

public class ActionEditorTest extends ComponentTestFixture {

    private Action action;
    private ActionEditor editor;

    protected void setUp() {
        action = new Action(new Script(), null,
                            "actionClick", new String[] {
                            "MethodSelector"
                            }, JComboBox.class);
        editor = new ActionEditor(action);
    }

    public void testComponentTesterMethodList() throws Throwable {
        showFrame(editor);

        ComponentReference cr =
            new ComponentReference("MethodSelector", JComboBox.class);
        JComboBox cb = (JComboBox)getFinder().findComponent(cr);
        action.getResolver().addComponent(cb);
        
        assertEquals("Wrong method selected",
                     "actionClick", cb.getSelectedItem());
        ArrayList list = new ArrayList();
        for (int i=0;i < cb.getItemCount();i++) {
            Log.debug("Got " + cb.getItemAt(i));
            list.add(cb.getItemAt(i));
        }
        assertTrue("No items in the list", cb.getItemCount() > 0);
        String[] expected = {
            "actionClick",
            "actionFocus",
            "actionKeyStroke",
            // Combo box methods
            "actionSelectIndex",
            "actionSelectItem",
        };
        for (int i=0;i < expected.length;i++) {
            assertTrue(expected[i] + " missing", list.contains(expected[i]));
        }
    }

    /** Construct a test case with the given name. */
    public ActionEditorTest(String name) {
        super(name);
    }

    /** Run the default test suite. */
    public static void main(String[] args) {
        TestHelper.runTests(args, ActionEditorTest.class);
    }
}
