package abbot.editor.editors;

import javax.swing.JComboBox;

import junit.extensions.abbot.ComponentTestFixture;
import junit.extensions.abbot.TestHelper;
import abbot.script.Call;
import abbot.script.ComponentReference;
import abbot.script.Script;

/** Verify CallEditor operation. */

public class CallEditorTest extends ComponentTestFixture {

    private Call call;
    private CallEditor editor;

    protected void setUp() {
        call = new Call(new Script(), null,
                        "java.lang.Object", "hashCode", null);
        editor = new CallEditor(call);
    }

    public void testMethodList() throws Throwable {
        showFrame(editor);
        ComponentReference cr = new ComponentReference("id", JComboBox.class);
        JComboBox cb = (JComboBox)getFinder().findComponent(cr);
        assertEquals("Wrong method selected",
                     cb.getSelectedItem(), "hashCode");
        String[] expected = {
            "equals",
            "getClass",
            "hashCode",
            "notify",
            "notifyAll",
            "toString",
            "wait",
        };
        assertEquals("Wrong number of methods",
                     expected.length, cb.getItemCount());
        for (int i=0;i < cb.getItemCount();i++) {
            assertEquals("Wrong method in combo list",
                         expected[i], cb.getItemAt(i));
        }
    }

    /** Construct a test case with the given name. */
    public CallEditorTest(String name) {
        super(name);
    }

    /** Run the default test suite. */
    public static void main(String[] args) {
        TestHelper.runTests(args, CallEditorTest.class);
    }
}
