package abbot.editor.recorder;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import junit.extensions.abbot.*;
import abbot.*;
import abbot.tester.awt.*;

/** Test recording of JComponent-specific events. */
public class JComponentRecorderTest 
    extends AbstractSemanticRecorderTest {

    private JComponentTester tester = (JComponentTester)
        ComponentTester.getTester(JComponent.class);

    public void testRecordActionMap() {
        JTextField tf = new JTextField("Operate here");
        showFrame(tf);

        tester.actionFocus(tf);
        startRecording();
        int mask = Toolkit.getDefaultToolkit().getMenuShortcutKeyMask();
        tester.key(KeyEvent.VK_A, mask);
        tester.waitForIdle();
        assertStep("ActionMap\\(.*,select-all\\)");
    }

    /** Create a new test case with the given name. */
    public JComponentRecorderTest(String name) {
        super(name);
    }

    protected SemanticRecorder createRecorder(Resolver r) {
        return new JComponentRecorder(r);
    }

    public static void main(String[] args) {
        RepeatHelper.runTests(args, JComponentRecorderTest.class);
    }
}
