package abbot.editor.recorder;

import javax.swing.JTextField;

import junit.extensions.abbot.RepeatHelper;
import abbot.Resolver;
import abbot.script.Action;
import abbot.script.Step;
import abbot.tester.awt.*;

/** Test recording of JTextComponent-specific events. */
public class JTextComponentRecorderTest 
    extends AbstractSemanticRecorderTest {

    private JTextComponentTester tester = new JTextComponentTester();
    public void testRecordSelection() {
        String text = "Select some text";
        JTextField tf = new JTextField(text);
        showFrame(tf);
        startRecording();
        tester.actionSelect(tf, 1, text.length()-1);
        Step step = getStep();
        assertStep("Select\\(.*,1," + (text.length()-1) + "\\)", step);
        assertEquals("Wrong component target",
                     javax.swing.text.JTextComponent.class.getName(),
                     ((Action)step).getTargetClassName());
    }

    /** Create a new test case with the given name. */
    public JTextComponentRecorderTest(String name) {
        super(name);
    }

    protected SemanticRecorder createRecorder(Resolver r) {
        return new JTextComponentRecorder(r);
    }

    public static void main(String[] args) {
        RepeatHelper.runTests(args, JTextComponentRecorderTest.class);
    }
}
