package abbot.editor.recorder;

import javax.swing.JTree;

import junit.extensions.abbot.RepeatHelper;
import abbot.Resolver;

import abbot.tester.awt.*;

/**
 * Unit test to verify proper capture of user semantic events on a JTree.
 */
public class JTreeRecorderTest 
    extends AbstractSemanticRecorderTest {

    private JTreeTester tester;
    private JTree tree;
    private static final int MAX_ENTRIES = 4;

    public JTreeRecorderTest(String name) {
        super(name);
    }

    protected SemanticRecorder createRecorder(Resolver r) {
        return new JTreeRecorder(r);
    }

    private void showTree() {
        tree = new JTree();
        tester = (JTreeTester)ComponentTester.getTester(tree);
        showFrame(tree);
    }

    public void testCaptureCellSelection() {
        showTree();
        startRecording();
        tester.actionSelectRow(tree, 1);
        assertStep("SelectRow\\(.*,1\\)");
    }

    public void testCaptureMultipleClick() {
        showTree();
        startRecording();
        int row = 2;
        tester.actionClickRow(tree, row, "BUTTON1_MASK", 2);
        assertStep("ClickRow\\(.*," + row + ",BUTTON1_MASK,2\\)");
    }

    public static void main(String[] args) {
        RepeatHelper.runTests(args, JTreeRecorderTest.class);
    }
}
