package abbot.editor.recorder;

import junit.extensions.abbot.TestHelper;
import junit.framework.Test;
import junit.framework.TestSuite;

/** 
    Full test suite for abbot.

    @author twall
*/

public class RecorderTestSuite extends TestSuite {

    public RecorderTestSuite(String name) {
        super(name);
    }

    /**
     * Assembles and returns a test suite containing tests for all available
     * ComponentRecorder derived classes.
     */
    public static Test suite() {
        Class[] classes = {
            ComponentRecorderTest.class,
            JComboBoxRecorderTest.class,
            JComponentRecorderTest.class,
            JListRecorderTest.class,
            JTabbedPaneRecorderTest.class,
            JTableRecorderTest.class,
            JTextComponentRecorderTest.class,
            WindowRecorderTest.class,
            JInternalFrameRecorderTest.class,
            ChoiceRecorderTest.class,
            // aggregator/coalescing
            EventRecorderTest.class,
        };
        // Test all the available recorders
        return TestHelper.generateSuite(classes);
    }

    /**
     * Runs the full test suite.
     */
    public static void main(String[] args) {
        TestHelper.runTests(args, RecorderTestSuite.class);
    }
}
