package abbot.editor.recorder;

import java.awt.*;

import javax.swing.JLabel;

import junit.extensions.abbot.RepeatHelper;
import abbot.Resolver;
import abbot.tester.awt.*;

/**
 * Unit test to verify proper capture of user semantic events on a Window.
 */
public class WindowRecorderTest 
    extends AbstractSemanticRecorderTest {

    private Window window;
    private WindowTester tester = new WindowTester();

    public WindowRecorderTest(String name) {
        super(name);
    }

    protected SemanticRecorder createRecorder(Resolver r) {
        return new WindowRecorder(r);
    }

    protected void showWindow() {
        Frame frame = showFrame(new JLabel(getName()));
        window = new Window(frame);
        window.add(new JLabel("One big label"));
        showWindow(window);
    }

    public void testCaptureResize() {
        showWindow();
        startRecording();
        tester.actionResize(window, 200, 200);
        assertEquals("Window not resized", new Dimension(200, 200),
                     window.getSize());
    }

    public void testCaptureMove() {
        showWindow();
        startRecording();
        tester.actionMove(window, 200, 200);
        assertEquals("Window not moved", new Point(200, 200),
                     window.getLocationOnScreen());
    }

    public static void main(String[] args) {
        RepeatHelper.runTests(args, WindowRecorderTest.class);
    }
}
