package abbot.script;

import junit.framework.Test;
import junit.framework.TestSuite;
import abbot.Log;

/** 
    Test suite for script package.

    @author twall
*/

public class AllTests extends TestSuite {

    public AllTests(String name) {
        super(name);
    }

    /**
     * Assembles and returns a test suite containing all the tests we'd like to
     * run on a regular basis.
     */
    public static Test suite() {
        TestSuite suite = new TestSuite();
        Class[] classes = {
            ComponentReferenceTest.class,
            ArgumentParserTest.class,
            //StepTest.class,
            CallTest.class,
            PropertyCallTest.class,
            SampleTest.class,
            ActionTest.class,
            AssertTest.class,
            AnnotationTest.class,
            //SequenceTest.class,
            ScriptTest.class,
            StepRunnerTest.class,
            ForkedStepRunnerTest.class,
        };
        // Misc framework tests
        for (int i=0;i < classes.length;i++) {
            try {
                java.lang.reflect.Method suiteMethod =
                    classes[i].getMethod("suite", null);
                suite.addTest((Test)suiteMethod.invoke(null, null));
            }
            catch(Exception exc) {
                suite.addTest(new TestSuite(classes[i]));
            }
        }
        return suite;
    }

    /**
     * Runs the full test suite.
     */
    public static void main(String[] args) {
        args = Log.init(args);

        String[] names = { AllTests.class.getName() };
        if (args.length == 1 && args[0].equals("--gui")) {
            junit.swingui.TestRunner.main(names);
        }
        else {
            junit.textui.TestRunner.main(names);
        }
    }
}
