package abbot.tester.awt;

import java.awt.Component;
import java.awt.image.BufferedImage;
import java.io.File;

import javax.swing.*;

import junit.extensions.abbot.*;
import junit.framework.TestCase;

import abbot.tester.awt.*;

/** Test ImageComparator. */

public class ImageComparatorTest extends ComponentTestFixture {

    private ImageComparator ic = new ImageComparator();
    private ComponentTester tester =
        ComponentTester.getTester(Component.class);

    // FIXME fails on linux; robot seems to only capture the blue
    // channel... 
    public void testImageCompare() throws Throwable {
        File gif = new File("test/abbot/tester/image.gif");
        ImageIcon icon = new ImageIcon(gif.toURL());
        JLabel label = new JLabel(icon);
        showFrame(label);
        tester.actionFocus(label);
        BufferedImage img = tester.capture(label);
        ImageComparator ic = new ImageComparator();
        File jpg = new File("test/abbot/tester/image.jpg");
        assertTrue("Images should not differ", ic.compare(img, jpg) == 0);
    }

    /** Create a new test case with the given name. */
    public ImageComparatorTest(String name) {
        super(name);
    }

    /** Return the default test suite. */
    public static void main(String[] args) {
        TestHelper.runTests(args, ImageComparatorTest.class);
    }
}
