package abbot.tester.awt;

import junit.extensions.abbot.TestHelper;
import junit.framework.Test;
import junit.framework.TestSuite;

/** 
    Test suite of all available tests for ComponentTester classes.
    <p>
    Note that the tester tests are set up to run multiple times when run
    standalone (the main method is invoked).  This makes it easy to
    stress-test the tester to expose timing-related issues, while not
    overburdening the main suite() method used here.
    <p>
    @author twall
*/

public class TesterTestSuite extends TestSuite {

    public TesterTestSuite(String name) {
        super(name);
    }

    /**
     * Assembles and returns a test suite containing tests for all available
     * ComponentTester derived classes.
     */
    public static Test suite() {
        Class[] classes = {
            // basic
            RobotTest.class,
            RobotAWTModeTest.class,
            ComponentTesterTest.class,
            // derived
            AbstractButtonTesterTest.class,
            FrameTesterTest.class,
            JComboBoxTesterTest.class,
            JComponentTesterTest.class,
            JListTesterTest.class,
            JTabbedPaneTesterTest.class,
            JTableTesterTest.class,
            JTreeTesterTest.class,
            ChoiceTesterTest.class,
        };
        // Test all the available testers
        return TestHelper.generateSuite(classes);
    }

    /**
     * Runs the full test suite.
     */
    public static void main(String[] args) {
        TestHelper.runTests(args, TesterTestSuite.class);
    }
}
