
package com.ibm.abbot.tester.swt;

import org.eclipse.swt.widgets.*;
import org.eclipse.swt.*;


public class ListTesterTest extends WidgetTestFixture{
	ListSample app;
	Shell shell;
	static ListTester tester;
		
	class ListSample{
		public Shell shell;
		public List list;
		public String[] items={ "Apples","Oranges","Bananas","Grapefruit",
								"Peaches","Kiwi","Apricots","Strawberries",
								"Apples","Oranges","Bananas","Grapefruit",
								"Peaches","Kiwi","Apricots","Strawberries"};		
		public ListSample(Shell shell){
			this.shell =shell;
			list = new List(shell,SWT.MULTI|SWT.H_SCROLL|SWT.V_SCROLL|SWT.BORDER);
			list.setItems(items);
			shell.pack();
		}
	};
	
	static{
		tester = (ListTester)WidgetTester.getTester(List.class);
	}
	
	
	public void setUp(){
		shell = createShell();
		app = new ListSample(shell);		
		showShell(shell);
	}
	
	public void tearDown(){
		hideShell(shell);
	}
	
	public void testSelection(){
		tester.actionSelectIndex(app.list,1);
		assertTrue("Failed to select item 1 by index",app.list.isSelected(1));	
	
		tester.actionSelectItem(app.list,"Bananas");
		assertTrue("Failed to select item 2 by name",app.list.isSelected(2));
		assertTrue("Selecting item 2 unproperly unselected item 1",app.list.isSelected(1));
				
		boolean threwException = false;
		try{
			tester.actionSelectItem(app.list,"Avacado");
		}catch(ActionFailedException e){
			threwException = true;
		}
		if(!threwException)
			fail("Failed to throw ActionFailedException");
	
		tester.actionSelectIndex(app.list,1);
		assertFalse("Failed to unselect item 1",app.list.isSelected(1));
	}
	
	public void testClick(){
		app.list.setSize(100,100);
		tester.actionWaitForIdle(app.list.getDisplay());
		Robot.delay(500);	
		
		tester.actionClickIndex(app.list,0);
		Robot.delay(500);
		assertTrue("Failed to click item 0",app.list.isSelected(0));
		
		tester.actionClickIndex(app.list,3);
		Robot.delay(500);
		assertTrue("Failed to click item 3", app.list.isSelected(3));

		tester.actionClickIndex(app.list,7);
		Robot.delay(500);
		assertTrue("Failed to click item 7",app.list.isSelected(7));
	
		tester.actionClickIndex(app.list,15);
		Robot.delay(500);
		assertTrue("Failed to click item 15", app.list.isSelected(15));
	}
}
