
package com.ibm.abbot.tester.swt;

import junit.extensions.abbot.*;

import org.eclipse.swt.widgets.*;
import org.eclipse.swt.*;

import junit.framework.*;

import com.ibm.abbot.examples.*;

public class TableTesterTest extends TestCase{
	static TableSample app;
	TableTester tester = (TableTester)WidgetTester.getTester(Table.class);
			
	public TableTesterTest(String name){
		super(name);
	}
	//static boolean ready = false;

	public void setUp(){
		Thread t = new Thread(){
			public void run(){
				Display display0 = new Display();
				app = new TableSample(display0);				
		
				while(!app.shell.isDisposed()){
					if(!display0.readAndDispatch())
						display0.sleep();			
				}
			}
		};
		t.setName("appThread");
		t.start();			
		WidgetTester.waitForFrameShowing("Table Sample");
	}
	
	public void tearDown(){
		app.shell.getDisplay().syncExec(new Runnable(){
			public void run(){
				app.shell.close();
				//app.shell.getDisplay().dispose();
			}			
		});
	}
	
	public void testSelectionAndChecking(){
		tester.actionSelectTableItem(app.table,app.items[3]);
		TableItem[] items = tester.getSelectedTableItems(app.table);
		assertTrue("Item 3 not selected by item",app.items[3]==items[0]);
		Robot.delay(250);
		
		tester.actionSelectTableIndex(app.table,2);
		items = tester.getSelectedTableItems(app.table);
		assertTrue("Failed to select multiple items",items.length==2);
		assertTrue("Item 2 not selected by index", app.items[2]==items[0] || 
					app.items[2]==items[1]);
		Robot.delay(250);
		
		tester.actionCheckTableItem(app.table,app.items[0]);
		items = tester.getCheckedTableItems(app.table);
		assertTrue("Item 0 not checked by item",app.items[0]==items[0]);
		Robot.delay(250);
		
		tester.actionCheckTableIndex(app.table,4);
		items = tester.getCheckedTableItems(app.table);
		assertTrue("Item 4 not checkd by index",app.items[4]==items[0] ||
					app.items[4]==items[1]);
		Robot.delay(250);
		
	}
	
	
	boolean selected ;
	public void testSelectTableColumn(){
		Robot.syncExec(app.table.getDisplay(),null,new Runnable(){
			public void run(){
				app.cols[2].addListener(SWT.Selection,new Listener(){
					public void handleEvent(Event e){
						selected = true;
					}
				});	
				app.cols[1].addListener(SWT.Selection,new Listener(){
					public void handleEvent(Event e){
						selected = true;
					}
				});	
							
			}			
		});
		
		selected = false;
		tester.actionClickTableColumnHeader(app.table,app.cols[2]);
		tester.actionDelay(500);
		assertTrue("Failed to select column 2", selected);

		selected =false;
		tester.actionClickTableColumnHeader(app.table,app.cols[1]);
		tester.actionDelay(500);
		assertTrue("Failed to select column 1", selected);
	}
	
	public void testUnselect(){
		tester.actionSelectTableItem(app.table,app.items[0]);
		Robot.delay(300);
		tester.actionSelectTableItem(app.table,app.items[0]);
	
		int[] selection = tester.getSelectedTableIndices(app.table);
		boolean selected =false;
		for(int i=0; i<selection.length;i++){
			if(selection[i]==0)
				selected = true;
		}
		
		assertTrue("Failed to unselect item 0",!selected);
	}

	// TODO test on tables with images in the items and cols
	
	public static void main(String[] args) {
		RepeatHelper.runTests(args, TableTesterTest.class);
	}
}
