
package com.ibm.abbot.tester.swt;

import org.eclipse.swt.widgets.*;
import org.eclipse.swt.*;

public class TextTesterTest extends WidgetTestFixture{
	TextTester tester;

	public TextTesterTest(String name){
		super(name);
		tester = (TextTester)WidgetTester.getTester(Text.class);		
	}

	public void testSetText() {
		Shell shell = createShell();
		shell.setLayout(null);
		Text text = new Text(shell,SWT.MULTI|SWT.WRAP);
		text.setSize(190,190);
				
		showShell(shell);
		
		String string = "short";
		tester.actionEnterText(text,string);
		assertEquals("Wrong short text typed,", string, text.getText());
		string = "longer";
		tester.actionEnterText(text,string);
		assertEquals("Wrong replacement text,",
			string, text.getText());
		string = "Some longer text that will surely exceed the field width";
		tester.actionEnterText(text,string);
		assertEquals("Wrong long replacement text,",
			string, text.getText());
		string = "shorter";
		tester.actionEnterText(text,string);
		assertEquals("Wrong shorter replacement text,",
			string, text.getText());
	
		hideShell(shell);
	}
	
	public void testSelection(){
		Shell shell = createShell();
		shell.setLayout(null);
		Text text = new Text(shell,SWT.MULTI|SWT.WRAP);
		text.setSize(190,190);
				
		showShell(shell);
		
		String string = "short";
		tester.actionEnterText(text,string);
		tester.actionSelect(text,0,string.length());
		assertEquals("Wrong selection start",
					 0, text.getSelection().x);
		assertEquals("Wrong selection end",
					 string.length(),text.getSelection().y);
		tester.actionSelect(text, 1, string.length()-1);
		assertEquals("Wrong selection start",
					 1, text.getSelection().x);
		assertEquals("Wrong selection end",
					 string.length()-1, text.getSelection().y);
					 
		hideShell(shell);		
	}

	public void testLongSelection() {
		Shell shell = createShell();
		shell.setLayout(null);
		Text text = new Text(shell,SWT.MULTI|SWT.WRAP);
		text.setSize(190,190);
				
		showShell(shell);		
		// Try a long selection which exceeds the visible area
		String string = "The quick brown fox jumped over the lazy dog";
		text.setText(string);
		TextTester.waitForIdle(shell.getDisplay());
		tester.actionSelect(text, 0, string.length());
		assertEquals("Wrong selection start",
					 0, text.getSelection().x);
		assertEquals("Wrong selection end",
					 string.length(), text.getSelection().y);
		tester.actionSelect(text, 1, string.length()-1);
		assertEquals("Wrong selection start",
					 1, text.getSelection().x);
		assertEquals("Wrong selection end",
					 string.length()-1, text.getSelection().y);
					 
		hideShell(shell);
	}
	
}

