package test;

import java.awt.AWTEvent;
import java.awt.Toolkit;
import java.awt.event.AWTEventListener;
import java.util.ArrayList;
import java.util.Iterator;

import abbot.editor.recorder.EventRecorder;
import abbot.tester.awt.*;
import abbot.util.EventNormalizer;

public class EventWatcher implements AWTEventListener {
    protected ArrayList events = new ArrayList();
    private EventNormalizer normalizer = new EventNormalizer();
        
    public void startListening(long mask) {
        events.clear();
        normalizer.startListening(this, mask);
    }

    public void stopListening() {
        normalizer.stopListening();
    }

    public void eventDispatched(AWTEvent event) {
        synchronized(events) {
            events.add(event);
        }
    }

    private static final String LS = System.getProperty("line.separator");

    public void clear() {
        synchronized(events) {
            events.clear();
        }
    }

    public String listEvents() {
        String msg = "The generated event stream was the following:";
        synchronized(events) {
            Iterator iter = events.iterator();
            if (!iter.hasNext()) {
                msg += LS + "(No events were captured)";
            }
            else while (iter.hasNext()) {
                AWTEvent ev = (AWTEvent)iter.next();
                msg += LS + ComponentTester.toString(ev);
            }
        }
        return msg;
    }
}
